#include <bits/stdc++.h>
#define mp make_pair
using namespace std;

long long n, a[200000], b[50], q, t, k, x;

int main() {
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin>>n;
    for(int i=1; i<=n; i++) {
        cin>>a[i];
        for(int j=0; j<30; j++) {
            if(a[i]&(1<<j)) b[j]++;
        }
    }
    cin>>q;
    while(q--) {
        cin>>t;
        if(t) {
            cin>>k>>x;
            for(int j=0; j<30; j++) {
                if(a[k]&(1<<j)) b[j]--;
            }
            a[k]=x;
            for(int j=0; j<30; j++) {
                if(a[k]&(1<<j)) b[j]++;
            }
        }
        else {
            cin>>k;
            x=0;
            for(int j=0; j<30; j++) {
                if(b[j]>=k) x+=(1<<j);
            }
            cout<<x<<'\n';
        }
    }
    return 0;
}